# include <ohana.h>
# include <dvo.h>
# include <kapa.h>
# include <signal.h>
# include <assert.h>
# include <pthread.h>

// choose off_t or int depending on full-scale relphot analysis resources
// # define IDX_T off_t
# define IDX_T int 

typedef enum {
  MODE_SIMPLE,
  MODE_CHIP,
  MODE_MOSAIC,
} CoordMode;

typedef enum {ERROR_MODE_RA, ERROR_MODE_DEC, ERROR_MODE_POS} ErrorMode;

typedef enum {FIT_NONE, FIT_AVERAGE, FIT_PM_ONLY, FIT_PAR_ONLY, FIT_PM_AND_PAR} FitMode;

typedef enum {TARGET_NONE, TARGET_SIMPLE, TARGET_CHIPS, TARGET_MOSAICS, TARGET_HIGH_SPEED, TARGET_MERGE_SOURCE, TARGET_UPDATE_OBJECTS, TARGET_UPDATE_OFFSETS, TARGET_LOAD_OBJECTS} FitTarget;

typedef enum {
  MARK_MEAS_DEFAULT  = 0x0000,
  MARK_TOO_FEW_MEAS  = 0x0001,
  MARK_NAN_POS_ERROR = 0x0002,
  MARK_NAN_MAG_ERROR = 0x0004,
  MARK_BIG_MAG_ERROR = 0x0008,
  MARK_BIG_OFFSET    = 0x0010,
} MeasurementMask;

typedef struct {
  Average     *average;	      // array of (minimal) average data
  MeasureTiny *measure;	      // array of (minimal) measure data 
  SecFilt     *secfilt;	      // array of secfilt data (matched to average by Nsecfilt)
  off_t       Naverage;
  off_t       Nmeasure;
} BrightCatalog;

typedef struct {
  Catalog *catalog;	      // array of catalogs generated
  int NCATALOG;		      // number of catalogs allocated
  int Ncatalog;		      // number of catalogs generated
  int Nsecfilt;		      // number of catalogs generated
  off_t *NAVERAGE; 	      // allocated Averages per catalog
  off_t *NMEASURE;	      // allocated Measures per catalog
  int   *index;		      // lookup table catID -> catalog[i]
  int   *catIDs;	      // lookup table catID <- catalog[i]
  int    maxID;		      // max catID value to date
} CatalogSplitter;

typedef struct {
  double R, D;  /* Sky Coords    - degrees */
  double P, Q;  /* Tangent Plane - pixels  */
  double L, M;  /* Focal Plane   - pixels  */
  double X, Y;  /* Chip Coords   - pixels  */
  double Mag;
  double dMag;
  double dPos;
  int mask;
  int Nmeas;
} StarData;

// structure to hold coordinate fitting terms
typedef struct {
    int Npts;
    int Nterms;
    int Norder;
    int Nsums;
    int Nelems;
    double **sum;
    double **xsum;
    double **ysum;
    double **xfit;
    double **yfit;
} CoordFit;

typedef struct {
  double Ro, dRo;
  double Do, dDo;

  double uR, duR;
  double uD, duD;

  double p, dp;

  double chisq;
  int Nfit;
} PMFit;

typedef struct {
  unsigned int start;
  unsigned int stop;
  float Mcal;
  float dMcal;
  short Xm;
  float secz;
  char flags;
  Coords coords;
} Mosaic;

typedef struct {
  double median;
  double mean;
  double sigma;
  double error;
  double chisq;
  double min;
  double max;
  double total;
  int    Nmeas;
} StatType;

# define MARKTIME(MSG,...) { \
  float dtime; \
  gettimeofday (&stop, (void *) NULL); \
  dtime = DTIME (stop, start); \
  fprintf (stderr, MSG, __VA_ARGS__); }

/* global variables set in parameter file */
# define DVO_MAX_PATH 1024
char   ImageCat[DVO_MAX_PATH];
char   GSCFILE[DVO_MAX_PATH];
char   CATDIR[DVO_MAX_PATH];
char   *HIGH_SPEED_DIR;
char   CATMODE[16];    /* raw, mef, split, mysql */
char   CATFORMAT[16];  /* internal, elixir, loneos, panstarrs */
char   SKY_TABLE[DVO_MAX_PATH];
int    SKY_DEPTH;  /** XXX EAM : depth of catalog tables, fix usage */

int          HOST_ID;
char        *HOSTDIR;
char        *BCATALOG;

unsigned int OBJ_ID_SRC;
unsigned int CAT_ID_SRC;
unsigned int OBJ_ID_DST;
unsigned int CAT_ID_DST;

double SIGMA_LIM;
int SRC_MEAS_TOOFEW; //catalog objects wich fewer detections then this are ignored
double MIN_ERROR;

int    IMFIT_CLIP_NITER; // number of clipping iterations to perform in FitChip
double IMFIT_CLIP_NSIGMA; // number of sigma to clip in FitChip
double IMFIT_SYS_SIGMA_LIM; // max dMag for objects used to measure systematic scatter

double RADIUS; // match radius for high-speed objects

int    PARALLEL;
int    PARALLEL_MANUAL;
int    PARALLEL_SERIAL;

int    PARALLEL_OUTPUT;

int    VERBOSE;
int    VERBOSE2;

int    RESET;
int    NLOOP;
int    NTHREADS;
int    UPDATE;
int    PLOTSTUFF;
int    SAVEPLOT;
int    SHOW_PARAMS;
char   STATMODE[32];
int    POS_TOOFEW;
int    PM_TOOFEW;
double PM_DT_MIN;
double PAR_FACTOR_MIN;
int    PLOTDELAY;
int    CHIPORDER;

int MaxDensityUse;
double MaxDensityValue;

char          *PHOTCODE_KEEP_LIST, *PHOTCODE_SKIP_LIST;
int           NphotcodesKeep,      NphotcodesSkip;
PhotCode     **photcodesKeep,     **photcodesSkip;

char          *PHOTCODE_A_LIST,  *PHOTCODE_B_LIST;
int           NphotcodesGroupA,  NphotcodesGroupB;
PhotCode     **photcodesGroupA, **photcodesGroupB;
char          WHERE_A[10000],          WHERE_B[10000];
SkyRegionSelection SELECTION;

int ImagSelect;
double ImagMin, ImagMax;

double  PlotMmin, PlotMmax, PlotdMmin, PlotdMmax;

int PhotFlagSelect, PhotFlagPoor, PhotFlagBad;

int TimeSelect;
time_t TSTART, TSTOP;

int FlagOutlier;
int    CLIP_THRESH;
int USE_BASIC_CHECK;

FitMode FIT_MODE;

FitTarget FIT_TARGET;

SkyRegion UserPatch;

int DoUpdateObjects;
int DoUpdateSimple;
int DoUpdateChips;
int DoUpdateMosaics;

// StarMap parameters:
int NX_MAP;
int NY_MAP;
double DPOS_MAX;
double ADDSTAR_RADIUS;

/*** relphot prototypes ***/
void          ConfigInit          PROTO((int *argc, char **argv));
void          GetConfig           PROTO((char *config, char *field, char *format, int N, void *ptr));
char         *GetPhotnamebyCode   PROTO((PhotCodeData *photcodes, int code));
void          InterpolateGrid     PROTO((float *buffer, int Nx, int Ny, Coords *ccd, Coords *gcoords));
off_t        *SelectRefMosaic     PROTO((Mosaic **refmosaic, off_t *Nimage));
int           args                PROTO((int argc, char **argv));
int           args_client         PROTO((int argc, char **argv));
int           bcatalog            PROTO((Catalog *subcatalog, Catalog *catalog));
void          clean_images        PROTO((void));
void          clean_measures      PROTO((Catalog *catalog, int Ncatalog, int final));
void          clean_mosaics       PROTO((void));
void          clean_stars         PROTO((Catalog *catalog, int Ncatalog));
int           corner_check        PROTO((double *x1, double *y1, double *x2, double *y2));
void          dumpGrid            PROTO((void));
void          dump_grid           PROTO((void));
int           edge_check          PROTO((double *x1, double *y1, double *x2, double *y2));
void          findImages          PROTO((Catalog *catalog, int Ncatalog, int MATCHCAT));
int           findMosaics         PROTO((Catalog *catalog, int Ncatalog));
Image        *find_images         PROTO((FITS_DB *db, GSCRegion *region, off_t Nregion, off_t *Nimage, off_t **LineNum));
void set_db (FITS_DB *in);
int Shutdown (char *format, ...) OHANA_FORMAT(printf, 1, 2);
void TrapSignal (int sig);
void SetProtect (int mode);
int SetSignals (void);

GSCRegion    *find_regions        PROTO((Image *image, off_t Nimage, int *Nregions, GSCRegion *fullregion));
void          freeGridBins        PROTO((int Ncatalog));
void          freeImageBins       PROTO((int Ncatalog));
void          freeMosaicBins      PROTO((int Ncatalog));
void          free_catalogs       PROTO((Catalog *catalog, int Ncatalog));
int           gcatalog            PROTO((Catalog *catalog, int FINAL));
// Coords       *getCoords           PROTO((off_t meas, int cat));
float         getMcal             PROTO((off_t meas, int cat));
float         getMgrid            PROTO((off_t meas, int cat));
float         getMmos             PROTO((off_t meas, int cat));
float         getMrel             PROTO((Catalog *catalog, off_t meas, int cat));
GSCRegion    *get_regions         PROTO((double minRa, double maxRa, double minDec, double maxDec, off_t *Nregions));
void          getfullregion       PROTO((Image *image, off_t Nimage, GSCRegion *fullregion));
Image        *getimage            PROTO((off_t N));
Image        *getimages           PROTO((off_t *N, off_t **line_number));
void          global_stats        PROTO((Catalog *catalog, int Ncatalog));
void          initGrid            PROTO((int dX, int dY));
void          initGridBins        PROTO((Catalog *catalog, int Ncatalog));
void          initImageBins       PROTO((Catalog *catalog, int Ncatalog, int FULLINIT));
void          initImages          PROTO((Image *input, off_t *line_number, off_t N));
void          initMosaicBins      PROTO((Catalog *catalog, int Ncatalog));
void          initMosaicGrid      PROTO((Image *image, off_t Nimage));
void          initMosaics         PROTO((Image *image, off_t Nimage));
void          initMrel            PROTO((Catalog *catalog, int Ncatalog));
void          initialize          PROTO((int argc, char **argv));
void          initialize_client   PROTO((int argc, char **argv));
void          initstats           PROTO((char *mode));
int           liststats           PROTO((double *value, double *dvalue, int N, StatType *stats));
Catalog      *load_catalogs       PROTO((SkyList *skylist, int *Ncatalog, int subselect, int hostID, char *hostpath));
int           load_images         PROTO((FITS_DB *db, SkyList *skylist));
Image        *select_images       PROTO((SkyList *skylist, Image *timage, off_t Ntimage, off_t **LineNumber, off_t *Nimage));

void check_permissions (char *basefile);
void lock_image_db (FITS_DB *db, char *filename);
void unlock_image_db (FITS_DB *db);
void create_image_db (FITS_DB *db);
void save_catalogs (Catalog *catalog, int Ncatalog);

int reload_images (FITS_DB *db);

int           main                PROTO((int argc, char **argv));
void          mark_images         PROTO((Image *image, off_t Nimage, Image *timage, off_t Ntimage));
void          matchImage          PROTO((Catalog *catalog, off_t meas, int cat, int MATCHCAT));
void          matchMosaics        PROTO((Catalog *catalog, off_t meas, int cat));
GSCRegion    *name_region         PROTO((char *name, off_t *Nregions));
double        opening_angle       PROTO((double x1, double y1, double x2, double y2, double x3, double y3));
void          plot_chisq          PROTO((Catalog *catalog, int Ncatalog));
void          plot_defaults       PROTO((Graphdata *graphdata));
void          plot_grid           PROTO((Catalog *catalog));
void          plot_images         PROTO((void));
void          plot_list           PROTO((Graphdata *graphdata, double *xlist, double *ylist, int N, char *label, char *file));
void          plot_mosaic_fields  PROTO((Catalog *catalog));
void          plot_mosaics        PROTO((void));
void          plot_scatter        PROTO((Catalog *catalog, int Ncatalog));
void          plot_star_coords    PROTO((Catalog *catalog, int Ncatalog));
void          plot_stars          PROTO((Catalog *catalog, int Ncatalog));
void          reload_catalogs     PROTO((SkyList *skylist));
int           setExclusions       PROTO((Catalog *catalog, int Ncatalog));
void          setMcal             PROTO((Catalog *catalog, int Poor));
void          setMcalFinal        PROTO((void));
int           setMcalOutput       PROTO((Catalog *catalog, int Ncatalog));
void          setMgrid            PROTO((Catalog *catalog));
int           setMmos             PROTO((Catalog *catalog, int Poor));
int           setMrel             PROTO((Catalog *catalog, int Ncatalog));
void          setMrelFinal        PROTO((Catalog *catalog));
int           setMrelOutput       PROTO((Catalog *catalog, int Ncatalog, int mark));
void          set_ZP              PROTO((double ZERO));
int           setrefcode          PROTO((Image *image, off_t Nimage));
void          skip_measurements   PROTO((Catalog *catalog, int pass));
void          sortA               PROTO((double *X, int N));
void          sortB               PROTO((double *X, double *Y, int N));
void          sortC               PROTO((double *X, double *Y, double *F1, double *F2, int N));
void          sortD               PROTO((double *X, double *Y, double *Z, int N));
StatType      statsImageM         PROTO((Catalog *catalog));
StatType      statsImageN         PROTO((Catalog *catalog));
StatType      statsImageX         PROTO((Catalog *catalog));
StatType      statsImagedM        PROTO((Catalog *catalog));
StatType      statsMosaicM        PROTO((Catalog *catalog));
StatType      statsMosaicN        PROTO((Catalog *catalog));
StatType      statsMosaicX        PROTO((Catalog *catalog));
StatType      statsMosaicdM       PROTO((Catalog *catalog));
StatType      statsStarN          PROTO((Catalog *catalog, int Ncatalog));
StatType      statsStarS          PROTO((Catalog *catalog, int Ncatalog));
StatType      statsStarX          PROTO((Catalog *catalog, int Ncatalog));
void          wcatalog            PROTO((Catalog *catalog));
void          wimages             PROTO((void));
void          write_coords        PROTO((Header *header, Coords *coords));

double **array_init (int Nx, int Ny);
void array_free (double **array, int Nx);
CoordFit *fit_init (int order);
void fit_free (CoordFit *fit);
void fit_add (CoordFit *fit, double x1, double y1, double x2, double y2, double wt);
int fit_eval (CoordFit *fit);
void fit_apply (CoordFit *fit, double *x2, double *y2, double x1, double y1);
double **poly2d_dx (double **poly, int Nx, int Ny);
double **poly2d_dy (double **poly, int Nx, int Ny);
double **poly2d_copy (double **poly, int Nx, int Ny);
double poly2d_eval (double **poly, int Nx, int Ny, double x, double y);
int fit_apply_coords (CoordFit *fit, Coords *coords, int keepRef);
int CoordsGetCenter (CoordFit *fit, double tol, double *xo, double *yo);
CoordFit *CoordsSetCenter (CoordFit *input, double Xo, double Yo);
int FitChip (StarData *raw, StarData *ref, int Nmatch, Image *image);
void FitMosaic (StarData *raw, StarData *ref, int Nmatch, Coords *coords);
void FitSimple (StarData *raw, StarData *ref, int Nmatch, Coords *coords);
void initObjectData (Catalog *catalog, int Ncatalog);
int UpdateObjects (Catalog *catalog, int Ncatalog);
int UpdateSimple (Catalog *catalog, int Ncatalog);
int UpdateChips (Catalog *catalog, int Ncatalog);
int UpdateMosaic (Catalog *catalog, int Ncatalog);
int UpdateMeasures (Catalog *catalog, int Ncatalog);
void fixImageRaw (Catalog *catalog, int Ncatalog, off_t im);
void FlagOutliers(Catalog *catalog);
int MeasFilterTest(Measure *measure, int applySigmaLim);
int MeasFilterTestTiny(MeasureTiny *measure, int applySigmaLim);

int sun_ecliptic (double jd, double *lambda, double *beta, double *epsilon, double *Radius);
int ParFactor (double *pR, double *pD, double RA, double Dec, double Time, double Tmean);
int FitPM (PMFit *fit, double *X, double *dX, double *Y, double *dY, double *T, int Npts, int XVERB);
int FitPar (PMFit *fit, double *X, double *dX, double *Y, double *dY, double *pR, double *pD, int Npts);
int FitPMandPar (PMFit *fit, double *X, double *dX, double *Y, double *dY, double *T, double *pR, double *pD, int Npts, int XVERB);

Mosaic *getMosaicForImage (off_t N);

StarData *getImageRef (Catalog *catalog, int Ncatalog, off_t im, off_t *Nstars, CoordMode mode);
StarData *getImageRaw (Catalog *catalog, int Ncatalog, off_t im, off_t *Nstars, CoordMode mode);
off_t getImageByID (off_t ID);

Mosaic *getmosaics (off_t *N);
void initMosaics (Image *image, off_t Nimage);
StarData *getMosaicRaw (Catalog *catalog, int Ncatalog, off_t mos, off_t *Nstars);
StarData *getMosaicRef (Catalog *catalog, int Ncatalog, off_t mos, off_t *Nstars);
Mosaic *getMosaicForImage (off_t im);

double getMeanR (MeasureTiny *measure, Average *average, SecFilt *secfilt);
double getMeanD (MeasureTiny *measure, Average *average, SecFilt *secfilt);
int setMeanR (double ra_fit, MeasureTiny *measure, Average *average, SecFilt *secfilt);
int setMeanD (double dec_fit, MeasureTiny *measure, Average *average, SecFilt *secfilt);
int setMeanR_Big (double ra_fit, Measure *measure, Average *average, SecFilt *secfilt);
int setMeanD_Big (double dec_fit, Measure *measure, Average *average, SecFilt *secfilt);

float GetAstromError (Measure *measure, int mode);
float GetAstromErrorTiny (MeasureTiny *measure, int mode);
int relastro_objects (SkyList *skylist, int hostID, char *hostpath);
int relastro_images (SkyList *skylist);
int UpdateObjectOffsets (SkyList *skylist, int hostID, char *hostpath);

int relastroVisualPlotChipFit(StarData *raw, StarData *ref, double dRmax, int numObj);
// int relastroVisualPlotRawRef(StarData *raw, StarData *ref, double dRmax, int numObj);
// int relastroVisualPlotScatter(double values[], double thresh, int npts);
// int relastroVisualPlotOutliers(Catalog *catalog, int offset, int Nmeasure, StatType statsR, StatType statsD, double thresh);
void relastroSetVisual(int state);
int relastroGetVisual(void);

int FixProblemImages (SkyList *skylist);
int *getCatlist (int *N, off_t im);

void initCoords (void);
void getOffsets (double *dPos, off_t *nPos, off_t N);
void saveOffsets (double dPos, off_t nPos, off_t N);
void setBadCoords (off_t N);
int badCoords (off_t N);
Coords *getCoords (off_t N);
int saveCoords (Coords *coords, off_t N);
void resetImageRaw (Catalog *catalog, int Ncatalog, off_t im);

int high_speed_catalogs (SkyTable *sky, SkyList *skylist, int hostID, char *hostpath);
int high_speed_objects (SkyRegion *region, Catalog *catalog);
int MeasMatchesPhotcode(Measure *measure, PhotCode **photcodeSet, int Nset);

int initStarMaps ();
int updateStarMaps(Catalog *catalog);
int createStarMapPoints();
int checkStarMap(int N);
int createStarMap (Catalog *catalog, int Ncatalog);

int GetScatterRawRef(float *dLsig, float *dMsig, float *dRsig, int *nKeep, StarData *raw, StarData *ref, int Nstars, float SigmaLimit);
int LimitDensityCatalog_ByNmeasure (Catalog *subcatalog, Catalog *catalog);
int LimitDensityCatalog_RandomSample (Catalog *subcatalog, Catalog *catalog);

int initializeConstraints();
int applyConstraintsA(Catalog *catalog, off_t i);
int applyConstraintsB(Catalog *catalog, off_t i);
void setupAreaSelection(SkyRegion *region);

int relastro_merge_source (SkyTable *sky);
void resort_catalog (Catalog *catalog);

BrightCatalog *BrightCatalogLoad(char *filename);
int BrightCatalogSave(char *filename, BrightCatalog *catalog);
BrightCatalog *BrightCatalogMerge (Catalog *catalog, int Ncatalog);
CatalogSplitter *BrightCatalogSplitInit (int Nsecfilt);
int BrightCatalogSplit (CatalogSplitter *catalogs, BrightCatalog *bcatalog);
int BrightCatalogSplitFree (CatalogSplitter *catalogs);

PhotCode **ParsePhotcodeList (char *rawlist, int *nphotcodes, int needAve);
